<template>
  <transition name="fade">
    <div v-if="isShow">
      <svg
        xmlns="http://www.w3.org/2000/svg"
        xmlns:xlink="http://www.w3.org/1999/xlink"
        viewBox="0 0 72 72"
        shape-rendering="geometricPrecision"
        text-rendering="geometricPrecision"
        :style="sizeStyle"
        class="ob-loader"
      >
        <defs>
          <clipPath id="preloader_1">
            <rect
              width="72"
              height="60"
              rx="0"
              ry="0"
              fill="rgb(0,0,0)"
              stroke="none"
              stroke-width="1"
            />
          </clipPath>
        </defs>
        <g transform="translate(36,36) rotate(0)">
          <g
            transform="translate(-36,-30)"
            clip-path="url(#preloader_1)"
          >
            <rect
              width="72"
              height="72"
              rx="0"
              ry="0"
              transform="matrix(1 0 0 1 0 -6.00000000000001)"
              fill="transparent"
              stroke="none"
              stroke-width="1"
            />
            <g transform="matrix(1 0 0 1 -115 -20)">
              <rect
                width="36"
                height="14"
                rx="0"
                ry="0"
                transform="matrix(1 0 0 1 151 43)"
                fill="rgb(0,74,199)"
                stroke="none"
                stroke-width="1"
              />
            </g>
            <circle
              r="30"
              transform="matrix(1 0 0 1 36 30)"
              fill="rgb(0,74,199)"
              stroke="none"
              stroke-width="1"
            />
            <circle
              r="13"
              transform="matrix(-1 0 -0 -1 36 30)"
              fill="#E4EDF9"
              stroke="none"
              stroke-width="1"
            />
            <circle
              r="6"
              transform="matrix(-1 0 -0 -1 36 30)"
              fill="rgb(0,74,199)"
              stroke="none"
              stroke-width="1"
            />
          </g>
        </g>
      </svg>
    </div>
  </transition>
</template>

<script>
export default {
  name: 'ObLoaderOboz',
  props: {
    width: {
      type: Number,
      default: 40
    },
    height: {
      type: Number,
      default: 40
    },
    duration: {
      type: Number,
      default: 4
    },
    delay: {
      type: Number,
      default: 0
    }
  },
  data () {
    return {
      isShow: false
    }
  },
  computed: {
    sizeStyle () {
      return `width: ${this.width}px; height: ${this.height}px; animation-duration: ${this.duration}s`
    }
  },
  mounted () {
    if (this.delay) {
      setTimeout(() => {
        this.isShow = true
      }, this.delay)
    } else {
      this.isShow = true
    }
  }
}
</script>

<style lang="scss" scoped>
.ob-loader {
  animation: ob-rotate infinite 2s;
}
@keyframes ob-rotate {
  0% {
    transform: rotate(0deg);
    animation-timing-function: cubic-bezier(0.190000, 1, 0.220000, 1)
  }
  25% {
    transform: rotate(90deg);
    animation-timing-function: cubic-bezier(0.230000, 1, 0.320000, 1)
  }
  50% {
    transform: rotate(180deg);
    animation-timing-function: cubic-bezier(0.230000, 1, 0.320000, 1)
  }
  75% {
    transform: rotate(270deg);
    animation-timing-function: cubic-bezier(0.230000, 1, 0.320000, 1)
  }
  100% {
    transform: rotate(360deg)
  }
}
</style>
